stages:
  - infer
  - testimage
  - test
  - check_ref
  - run_benchmark
  - generate_metrics
  - runway_staging
  - runway_production

variables:
  SERVICE_IMAGE:
    description: "scanner service docker image, inferred by infer_service_image."
  # OIDC configuration for accessing GCP credentials
  GCP_PROJECT_ID: "dev-sast-ide-bce06de6"
  WI_POOL_PROVIDER: "//iam.googleapis.com/projects/26625830128/locations/global/workloadIdentityPools/gitlab-pool-oidc-bm/providers/gitlab-jwt-bm"
  SERVICE_ACCOUNT: "benchmark@dev-sast-ide-bce06de6.iam.gserviceaccount.com"

include:
  - local: "ci-templates/runway.yml"
  - local: "ci-templates/benchmark.yml"

infer_service_image:
  image: alpine:latest
  stage: infer
  before_script:
    - apk add --no-cache git
  script:
    - |
      service_sha=$(git ls-tree HEAD --object-only ./sast-scanner-service)
      echo "SERVICE_IMAGE=registry.gitlab.com/gitlab-org/secure/sast-scanner-service/tmp:$service_sha-dev" >> service_image.env
      echo "STAGING_SERVICE_IMAGE=registry.gitlab.com/gitlab-org/secure/sast-scanner-service:$service_sha-staging" >> service_image.env
      echo "PRODUCTION_SERVICE_IMAGE=registry.gitlab.com/gitlab-org/secure/sast-scanner-service:$service_sha-production" >> service_image.env
      cat service_image.env
  artifacts:
    reports:
      dotenv: service_image.env

# make sure that the inferred images are actually available
test_service_image_availability:
  variables:
    # do not collapse multi-line command output
    FF_SCRIPT_SECTIONS: "true"
  image: docker:26
  stage: testimage
  services:
    - docker:26-dind
  script:
    - docker info
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker pull $SERVICE_IMAGE
    # Check the images used by runway deployment jobs when they are enabled
    - |
      if [ "$DEPLOY_BRANCH" == "true" ] || {
          [ "$CI_PIPELINE_SOURCE" == "push" ] && [ "$CI_COMMIT_BRANCH" == "$CI_DEFAULT_BRANCH" ]
      }; then
        docker pull $STAGING_SERVICE_IMAGE
        docker pull $PRODUCTION_SERVICE_IMAGE
      fi
